#include "CHCTraverser.h"

namespace CHCDemo
{

CHCTraverser::CHCTraverser(): RenderTraverser() 
{
}


CHCTraverser::~CHCTraverser()
{
	//DelQueries();
}


void CHCTraverser::Render()
{
#if 0
	QueryQueue queryQueue;

	//-- PART 1: process finished occlusion queries
	while (!mDistanceQueue.empty() || !queryQueue.empty())
	{
		while (!queryQueue.empty() && 
			   (ResultAvailable(queryQueue.front()) || mDistanceQueue.empty()))
		{
			HierarchyNode *node = queryQueue.front();
			queryQueue.pop();
			
			// wait until result available
			int visiblePixels = GetOcclusionQueryResult(node);

			if(visiblePixels > mVisibilityThreshold)
			{
				PullUpVisibility(node);
				TraverseNode(node);
			}
			else
			{
				mNumQueryCulledNodes ++;
			}
		}	

		//-- PART 2: hierarchical traversal
		if (!mDistanceQueue.empty())
		{
			HierarchyNode *node = mDistanceQueue.top();

			mDistanceQueue.pop();
	
			mNumTraversedNodes ++;

			bool intersects;
			
			if (InsideViewFrustum(node, intersects))
			{
				// for near plane intersecting bounding box possible 
				// wrong results => skip occlusion query
				if(intersects)
				{
					// update node's visited flag
					node->SetLastVisited(mFrameID);
					node->SetVisible(true);
					PullUpVisibility(node);
					TraverseNode(node);
				}
				else
				{		
					// identify previously visible nodes
					bool wasVisible = node->Visible() && (node->LastVisited() == mFrameID - 1);
					
					// identify nodes that we cannot skip queries for
					bool leafOrWasInvisible = (node->LastVisited() != mFrameID) && (!wasVisible || node->IsLeaf());

					// reset node's visibility classification 
					node->SetVisible(false);

					// update node's visited flag
					node->SetLastVisited(mFrameID);
					
					// skip testing previously visible interior nodes
					if(leafOrWasInvisible)
					{
						IssueOcclusionQuery(node, wasVisible);
						queryQueue.push(node);
					}
					
					// always traverse a node if it was visible
					if(wasVisible)
						TraverseNode(node);
				}
			}
			else
			{
				// for stats
				mNumFrustumCulledNodes ++;
			}
		}
	}
#endif
}

}