#ifndef _BinaryLoader_H__
#define _BinaryLoader_H__

// note use forward declaration instead
#include <string>
#include <iostream>
#include <fstream>
#include "common.h"


namespace CHCDemo
{

class igzstream;
class SceneEntity;
class Material;
class Geometry;


class BinaryLoader
{
public:

	bool Load(const std::string &filename, SceneEntityContainer &geometry);

protected:
	
	SceneEntity *LoadShape(std::ifstream &str);
	Material *LoadMaterial(std::ifstream &str);
	Geometry *LoadGeometry(std::ifstream &str);

	/*SceneEntity *LoadShape(igzstream &str);
	Material *LoadMaterial(igzstream &str);
	Geometry *LoadGeometry(igzstream &str);
	*/
};

}
#endif
